package serveur;


import client.Data;
import java.util.*;
import serveur.individus.Individus;
import serveur.individus.vivant.*;
import serveur.individus.environnement.*;


//////////////////////////////////////////////////////////////////////
// Lance la construction de la carte  partir et sur les donnes fournies 
// par ServeurImpl. 
//////////////////////////////////////////////////////////////////////

public class Carte {
    //    VecteurSerie listeTerrain;//=new VecteurSerie(nbCasesHoriz*nbCasesVert);
    //VecteurSerie listeIndividus=new VecteurSerie();
    ServeurImpl serv;
    int tailleX;
    int tailleY;
    int nbCasesHoriz;
    int nbCasesVert;
    int nbClients;
    int nbMoutons;
    int nbChiens;
    int nbLoups;
    int nbObstacles;
	
    public Carte(){};

    public void MiseAJour(int tX, int tY, int nbCasesH, int nbCasesV, int nbCli, int nbMout, int nbChi, int nbL, int nbO, ServeurImpl papa) {
	tailleX=tX;
	tailleY=tY;
	nbCasesHoriz=nbCasesH;
	nbCasesVert=nbCasesV;
	// A vrifier, bancal.
	nbClients=nbCli;
	nbMoutons=nbMout;
	nbChiens=nbChi;
	nbLoups=nbL;
	nbObstacles=nbO;
	serv=papa;
	//listeTerrain=new VecteurSerie(nbCasesHoriz*nbCasesVert);
	initTerrain();
	initOccupants();
    }


    /**
     * Operation
     * Initialise le terrain.
     */

    public void initTerrain() {
		int i, j, numeroPlaine;
		Random hasard=new Random(System.currentTimeMillis());
	
		    for (i=0;i<nbCasesHoriz*nbCasesVert;i++){              //  ModifMik
			numeroPlaine=hasard.nextInt(22)+1;
			Data panel = new Data("plaine" + numeroPlaine); 
			serv.ajouteTerrain((Data)panel/*.clone()*/);}  
		    
    }

    /**
     * Operation
     * Initialise et place les tres vivants.
     */
    public void initOccupants() {
		int i, j, espacementY;

		// grer le nb d'individus autre part dans un procdure d'initialisation
		// qui appartient au serveur
		int departX = tailleX/5;
		int departY = tailleY/5;
		Random hasard=new Random(System.currentTimeMillis());
		//	espacement=(int) ((tailleY-200)/(nbClients+1));		


	
		for(i = 0; i < nbObstacles ; i++){
		    serv.ajouteOccupant((Individus)(new Rocher(hasard.nextInt(tailleX), hasard.nextInt(tailleY), "localhost",serv)));
		}



		if (nbClients>1) {
		    espacementY = (tailleY-2*departY)/(nbClients);
		
	for (j=0;j < nbClients; j++) {
	    	serv.ajouteOccupant((Individus)(new Bergerie(tailleX-departX, tailleY-espacementY*(j+1), ((IdClient) (serv.listeClient.elementAt(j))).obtientNom(), j+1, serv)));		    

		    for(i = 0; i < nbMoutons; i++){
			serv.ajouteOccupant((Individus)(new Mouton(departX, departY + espacementY*j, serv)));
		    }
		    
		    
		    for(i = 0; i < nbLoups; i++){    
		        serv.ajouteOccupant((Individus)(new Loup(hasard.nextInt(tailleX-2*departX)+2*departX, hasard.nextInt(tailleY),((IdClient) (serv.listeClient.elementAt(j))).obtientNom(), j+1, serv)));
		     }

		    for(i = 0; i < nbChiens; i++){
			serv.ajouteOccupant((Individus)(new Chien(departX, departY + espacementY*j,((IdClient) (serv.listeClient.elementAt(j))).obtientNom(), j+1, serv)));
		    }
		    
		    
		    }

		 //Placer les loups libres.


		}
		else {
		    espacementY=400;

	    	serv.ajouteOccupant((Individus)(new Bergerie(tailleX-departX, tailleY-espacementY, ((IdClient) (serv.listeClient.elementAt(0))).obtientNom(), 1, serv)));
		    serv.ajouteOccupant((Individus)(new Bergerie(700, 700, ((IdClient) (serv.listeClient.elementAt(0))).obtientNom(), 1, serv)));

		    for(i = 0; i < nbLoups; i++){    
			serv.ajouteOccupant((Individus)(new Loup(hasard.nextInt(tailleX-2*departX)+2*departX, hasard.nextInt(tailleY),"", 1, serv)));
		    }

		    for(i = 0; i < nbMoutons; i++){
			serv.ajouteOccupant((Individus)(new Mouton(departX, departY + espacementY,serv)));
		    }

		    for(i = 0; i < nbChiens; i++){
			serv.ajouteOccupant((Individus)(new Chien(departX, departY, ((IdClient) (serv.listeClient.elementAt(0))).obtientNom(), 1, serv)));
		    }

		}
		
		 for(i = 0; i < nbObstacles/3 ; i++){
		    serv.ajouteOccupant((Individus)(new Rocher(hasard.nextInt(tailleX), hasard.nextInt(tailleY), "localhost",serv)));
		    }

		 for(i = 0; i < nbObstacles/2 ; i++){
		    serv.ajouteOccupant((Individus)(new Buisson(hasard.nextInt(tailleX), hasard.nextInt(tailleY), "localhost",serv)));
		    }

		 for(i = 0; i < nbObstacles/5 ; i++){
		    serv.ajouteOccupant((Individus)(new Mare(hasard.nextInt(tailleX), hasard.nextInt(tailleY), "localhost",serv)));
		    }		 

		 


    }

}
