package serveur;
import java.awt.*; 
import java.awt.event.*;
import javax.swing.*;
import java.io.IOException;
import serveur.*;
import client.Client;
import serveur.PanelImage;




public class EcranFin extends JFrame implements WindowListener{
        
    GridBagLayout gridbag = new GridBagLayout();
    GridBagConstraints c = new GridBagConstraints();
    
    JLabel legende=new JLabel("",JLabel.CENTER);
    JButton boutonNouveau=new JButton("Nouvelle Partie ?");
    JButton boutonQuitter=new JButton("Quitter");

    Client pere;

    private Image titre;
    private String nomImage;
    private PanelImage icone; 

    static private Font bigfont = new Font("TimesRoman", Font.BOLD,40);

class ActionNouveau implements ActionListener {
        public synchronized void actionPerformed(ActionEvent e) 
        {nouveauJeu();}
    };

class ActionQuitter implements ActionListener {
        public synchronized void actionPerformed(ActionEvent e) 
        {quitter();}
    };

    void nouveauJeu() {
	//	(new CroqueMouton()).main("");
	try {
	    Runtime.getRuntime().exec("java -Djava.security.policy=securite.txt serveur.CroqueMouton");}
	catch (java.io.IOException ex) {};
	dispose();
	pere.stoppeClient();
    }

    void quitter () {
	pere.stoppeClient();
	dispose();
    }

    public EcranFin (Resultat vainq, Client papa) {
	super ("CroqueMouton 1.0"); 
	pere=papa;
	addWindowListener(this);  //pour la fermeture de fenetre
	Dimension tailleEcran = Toolkit.getDefaultToolkit().getScreenSize();

	getContentPane().setLayout(gridbag);
	c.fill = GridBagConstraints.BOTH;

	nomImage="sprites/fin.gif";
	titre = Toolkit.getDefaultToolkit().createImage(nomImage);
	
	icone = new PanelImage(titre); 

	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(icone,c);
	getContentPane().add (icone);
	icone.setSize(836,100);

	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(legende,c);
	getContentPane().add (legende);

	c.gridwidth = GridBagConstraints.RELATIVE;
	gridbag.setConstraints(boutonNouveau,c);
	getContentPane().add (boutonNouveau);
	c.gridwidth = GridBagConstraints.REMAINDER;
	gridbag.setConstraints(boutonQuitter,c);
	getContentPane().add(boutonQuitter);
	boutonNouveau.addActionListener(new ActionNouveau());
	boutonQuitter.addActionListener(new ActionQuitter());
	legende.setFont(bigfont);
	legende.setText(vainq.nomGagnant+" avec "+vainq.moutonSauves+" moutons sauvs sur "+vainq.moutonTotal +"!");
	setLocation(tailleEcran.width-1000,tailleEcran.height/2-300);
	pack(); 
	setVisible(true);
    } 



/////////////////////////////////////////////////////////////////
// bidules et autre trucs de la classe JFrame  implementer
/////////////////////////////////////////////////////////////////
    public void windowClosing(WindowEvent e) {
	quitter();
		//	pere.marche=false;
	//	dispose();
    }
    
    public void windowClosed(WindowEvent e) {    }
    public void windowOpened(WindowEvent e) {    }
    public void windowIconified(WindowEvent e) {    }
    public void windowDeiconified(WindowEvent e) {    }
    public void windowActivated(WindowEvent e) {    }
    public void windowDeactivated(WindowEvent e) {    }
    public void windowGainedFocus(WindowEvent e) {    }
    public void windowLostFocus(WindowEvent e) {    }
    public void windowStateChanged(WindowEvent e) {    }


}
