package serveur;

import java.awt.*; 
import java.awt.event.*;
import javax.swing.*;
import serveur.*;
import client.*;


public class FenetreJoueurs extends JFrame implements WindowListener {
    JTextArea joueurs=new JTextArea("", 5, 10);
    JButton boutonJeu=new JButton("Lancer le jeu !");
    ServeurImpl serv;

    class ActionDemarre implements ActionListener {
        public synchronized void actionPerformed(ActionEvent e) 
        {demarreJeu();}
    };

    void demarreJeu () {
	serv.run();
	dispose();
    }

    public void windowClosed(WindowEvent e) {
    }
    public void windowOpened(WindowEvent e) {
    }
    public void windowIconified(WindowEvent e) {
    }
    public void windowDeiconified(WindowEvent e) {
    }
    public void windowActivated(WindowEvent e) {
    }
    public void windowDeactivated(WindowEvent e) {
    }
    public void windowGainedFocus(WindowEvent e) {
	}
    public void windowLostFocus(WindowEvent e) {
    }
    public void windowStateChanged(WindowEvent e) {
    }
    public void windowClosing(WindowEvent e) {
    }
   

    public FenetreJoueurs(ServeurImpl s) {
	super ("CroqueMouton 1.0");
	setSize(400,400);
	serv=s;
	getContentPane().add(joueurs, BorderLayout.NORTH);
	getContentPane().add(boutonJeu, BorderLayout.CENTER);
	boutonJeu.addActionListener(new ActionDemarre());
	setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	joueurs.setText("FenetreJoueurs");
	
	pack(); 
	setLocation(10,10);
	setVisible(true);
	addWindowListener(this);
    }
    
}
