package serveur;

//import java.util.*;
//import serveur.individus.*;
import serveur.individus.Individus;
import serveur.IdClient;

public interface Serveur extends java.rmi.Remote {
    public int nouveauClient (String nom, int etat) throws java.rmi.RemoteException;
    public void finClient (int num) throws java.rmi.RemoteException;
    public VecteurSerie donneTerrain() throws java.rmi.RemoteException;
    public VecteurSerie donneSituation() throws java.rmi.RemoteException;
    public int recupereMouvement ( int qui, int cibleHoriz, int cibleVert ) throws java.rmi.RemoteException;
    public int recuperePointDeRoute ( int qui, int cibleHoriz, int cibleVert ) throws java.rmi.RemoteException;
    public Resultat finPartie () throws java.rmi.RemoteException;
    public boolean demandePartieFinie () throws java.rmi.RemoteException;
    public String comTest() throws java.rmi.RemoteException;
    public VecteurSerie donneScore() throws java.rmi.RemoteException;
    public IdClient recupereIdClient(int numeroClient) throws java.rmi.RemoteException;
    public void majEffectuee(int numeroClient) throws java.rmi.RemoteException;
    public int donneTailleCarteHoriz() throws java.rmi.RemoteException;
    public int donneTailleCarteVert() throws java.rmi.RemoteException;

    //On ne doit pas mettre de fonction ne lanant pas java.rmi.RemoteException ici
    //	public void tuerVivant(int tue);
    //	public void ouSuisJe(Individus moi);
    //public boolean fini=false;
	// ne devrait pas tre ici, encore moins en 'public'
    //	public VecteurSerie occupants = new VecteurSerie();
}
