package serveur;

//import serveur.*;
//import serveur.individus.*;
import serveur.ServeurImpl;
import serveur.individus.Individus;

public class Tour implements Runnable {
	ServeurImpl pere;
	int delai;
	Thread tourdejeu;

/////////////////////////////////////////////////////////////////
// constructeur de la classe Tour
/////////////////////////////////////////////////////////////////

    public Tour (ServeurImpl serv,int delay) {
        pere = serv;
        delai = delay;

		// Cre un thread
		tourdejeu = new Thread(this);
		if(tourdejeu!=null){
			tourdejeu.start();
		};
    }


/////////////////////////////////////////////////////////////////
// lancement du thread
/////////////////////////////////////////////////////////////////

   public synchronized void run( ) {
	Individus idvtemp;
	int i;

	while (pere.fini==false) {
		Thread.currentThread().yield();
		// Lance 'action' pour chaque element de 'occupants' sur le serveur.
		for (i=0;i<(pere.occupants.size());i++){                            
   			idvtemp = ((Individus)(pere.occupants.elementAt(i)));
 			if(idvtemp.actif){idvtemp.action();}
		}
		Thread.currentThread().yield();
      	try {
	   		Thread.currentThread().sleep(delai);
	    } catch (Exception exc) { };
    }
   } 
}
