package serveur.individus;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.regex.Pattern;
import java.lang.reflect.Array;

/*
 *		A FAIRE :
 *
 *	Nouveau joueur : tester si le nom est dj pris
 *	Donner le bergeries  quelqu'un...
 *	Prendre en compte le rayon des objets
 *	Ne pas redimmensionner la fenetre quand 'E'
 *
 *
 */



public class Comportement{
	
	// Pour l'initialisation
	private Hashtable classVersEntier = new Hashtable();
	private String entierVersClass[]; 
	private int nbClasses = -1;		// est incrment avant utilisation

	private ComportementIndividu tousLesComportements[][];

	// est-ce que deux objets peuvent se chevaucher ???
	//private boolean comportementPassage[][];
	// est-ce attirant ou repoussant
	//private int comportementDeplacement[][];
	// Ce qu'on utilisera vraiment pour les comportements (manger, fuir)
	//private String comportementAction[][];
	//private int    comportementActionEnvie[][];

//////////////////////////////////////////////////////////////////////////////
//	Quels individus est-ce que cela concerne ?
//	Cration des tableaux de Comportement.
//////////////////////////////////////////////////////////////////////////////

	public void ajouteType(String nom){
		// Construit une Hashtable : classVersEntier : Mouton -> 1;
		if(!classVersEntier.containsKey(nom)){
			nbClasses++;
			classVersEntier.put(nom , new Integer(nbClasses));
		}else{
		}
	}
	
	public boolean correspond(String chaine, int classe){
		return entierVersClass[classe].indexOf(chaine) > 0;
	}
	
	public void ajouteAction(String source, String reaction, int envie, String cible){
		int i, j;
		for(i=0; i < nbClasses; i++){
			for(j=0; j < nbClasses; j++){
				if(correspond(source, i) && correspond(cible, j)){
					tousLesComportements[i][j].definirAction(reaction);
					tousLesComportements[i][j].definirEnvie(envie);					
				}
			}
		}
	}

	public void ajoutePassage(String source, boolean passage, String cible){
		int i, j;
		for(i=0; i < nbClasses; i++){
			for(j=0; j < nbClasses; j++){
				if(correspond(source, i) && correspond(cible, j)){
					tousLesComportements[i][j].definirPassage(passage);
				}
			}
		}
	}

	public void ajouteAttirance(String source, int attirance, String cible){
		int i, j;
		for(i=0; i < nbClasses; i++){
			for(j=0; j < nbClasses; j++){
				if(correspond(source, i) && correspond(cible, j)){
					tousLesComportements[i][j].definirAttirance(attirance);
				}
			}
		}
	}

	public void creeCommentReagir(){
		// Reconstruire: classVersEntier : 1 -> Mouton, de la taille de entierVersClass (nbClasses)
		// dfinir comment ragir de taille de nbClasses^2.
		nbClasses++;	//Nombres d'lmnts et plus numro maximal.
		String cle; int valeur, i, j;
		entierVersClass = new String[nbClasses];
		for (Enumeration e = classVersEntier.keys() ; e.hasMoreElements() ;) {
    	     cle = (String)(e.nextElement());
    	     valeur = ((Integer)classVersEntier.get(cle)).intValue();
    	     entierVersClass[valeur]=cle;	// On inverse le tableau
	    }
		tousLesComportements = new ComportementIndividu[nbClasses][nbClasses];
		for(i=0; i < nbClasses; i++){
			for(j=0; j < nbClasses; j++){
				tousLesComportements[i][j] = new ComportementIndividu();
			}
		}		
		initReagir();
	}

	public ComportementIndividu reagir(String moi, String lui){
		int intMoi = ((Integer)classVersEntier.get(moi)).intValue();
		int intLui = ((Integer)classVersEntier.get(lui)).intValue();
		return tousLesComportements[intMoi][intLui];
	};

	public void initReagir(){
		ajoutePassage(".", false, ".");	//A priori personne ne se chevauche
		ajouteAttirance(".", 0, ".");
		ajouteAction(".","", 0, ".");	//mise a zero.de tout;

		ajouteAction("Loup", "attaquer", 100, "Mouton");				
		ajouteAttirance("Loup", 1000, "Mouton");
		ajouteAttirance("Mouton", -1000, "Loup");

		ajouteAttirance("Mouton", -10000, "Chien");

		ajouteAction("Loup", "attaquer", 1000, "Chien");		// se dfend quand adoss au mur...			
		ajouteAction("Chien", "attaquer", 100, "Loup");				
		ajouteAttirance("Chien", 100, "Loup");
		ajouteAttirance("Loup" , -100, "Chien");
				
		ajouteAttirance("Mouton", 100, "Mouton");
		
		ajouteAction("Bergerie", "sauver", 1000, "Mouton");
		ajouteAttirance("Mouton", 1000, "Bergerie");
		

	}
}