package client;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.JOptionPane;
import javax.swing.JFrame;
import javax.swing.JDialog;
import java.beans.*;


/////////////////////////////////////////////////////////////////////
//Fenetre qui s'affiche lorsque le serveur est devenu inaccessible 
// (par exemple lorsque le possesseur de serveur a fait un Ctrl-C...
/////////////////////////////////////////////////////////////////////


public class FenetreErreurReseau extends JDialog implements PropertyChangeListener {

    Client pere;
    JFrame icone;
    JOptionPane panneauErreur=new JOptionPane("Le serveur est dsormais inaccessible ! Dsol !",
					  JOptionPane.ERROR_MESSAGE,
					  JOptionPane.DEFAULT_OPTION);


    public void propertyChange(PropertyChangeEvent e) {
	    pere.stoppeClient();
	    dispose();
	}


    FenetreErreurReseau(Client papa) {
	super();
	pere=papa;
	
	setContentPane(panneauErreur);
	setDefaultCloseOperation(JDialog.EXIT_ON_CLOSE);
	pack();
	show();
    

	addWindowListener(new WindowAdapter(){
		public void windowClosing(WindowEvent we) {
		    pere.stoppeClient();
		    dispose();
		}
	    });
	panneauErreur.addPropertyChangeListener(this);
    }
	
}
