package client;
import serveur.VecteurSerie;

public class GestionnaireTerrain {

  private VecteurSerie terrain = new VecteurSerie();   // le vecteur de string dcrivant le terrain de jeu
  private int taillecasehoriz; // largeur d'une case
  private int taillecasevert;  // hauteur d'une case
  static private int horiz, vert;      // taille de la fentre  l'cran
  static private int horiztot, verttot;   // taille totale du terrain de jeu
  private int nombrecasehoriz, nombrecasevert;
  private String nomdecase;
  private int compteur;
  private Fantome panel; 
  private GestionnaireFenetre fenetre;
  private Client pere;
    private String ambianceGraphique;
  
/////////////////////////////////////////////////////////////////
// constructeur
/////////////////////////////////////////////////////////////////
    public GestionnaireTerrain(int horizontal,int vertical,VecteurSerie terr, String ambiance,
GestionnaireFenetre fen, Client cli) 
   	{
    horiz = horizontal;
    vert = vertical;
    terrain = (VecteurSerie)(((VecteurSerie)terr));
    ambianceGraphique=ambiance;
    fenetre = fen;
    pere = cli;
    horiztot = pere.HORIZ_TOTAL;
    verttot = pere.VERT_TOTAL;
    // Toutes les cases font 100x100
    nombrecasehoriz = horiztot/100;
    nombrecasevert = verttot/100;
    taillecasehoriz = 100;
  	taillecasevert = 100;
    batiTerrain();
	}
	
	
/////////////////////////////////////////////////////////////////
// Conversion et Affichage du terrain
/////////////////////////////////////////////////////////////////
  
  public void batiTerrain() {
  for (compteur=0 ; compteur < terrain.size() ; compteur++)
  	{
  	 try {
    	 nomdecase = ambianceGraphique +((String)((Data)(terrain.elementAt(compteur))).getNom())+".gif";
   		 } catch (IndexOutOfBoundsException outof) {
            System.err.println("IndexOutOfBoundsException" + outof);
        	};
     panel = new Fantome(nomdecase,fenetre);
     panel.reglePosition(taillecasehoriz*(compteur%nombrecasehoriz),taillecasevert*(compteur/nombrecasehoriz));
     fenetre.construitTerrain((Fantome)(panel));
  	}
  }

}
