package serveur;
import java.rmi.Naming;
import java.rmi.RemoteException;
import java.net.MalformedURLException;
import java.rmi.NotBoundException;
import java.lang.CloneNotSupportedException;
import java.lang.Integer;
import java.util.*;
import serveur.individus.*;
import serveur.cases.plaine.*;
import serveur.individus.vivant.*;
import serveur.individus.environnement.*;
import serveur.cases.*;
import serveur.FenetreJoueurs;
import client.*;
import serveur.Carte;


/********************************************************************************
 *	Constructeur de ServeurImpl
 ********************************************************************************/
public class ServeurImpl extends java.rmi.server.UnicastRemoteObject implements Serveur {
    /** Attributes */
    //    private VecteurSerie temp;   // Pour avant que le jeu soit lanc
    // actuellement dans serveur
    // a mettre ici, il faut faire un rmic
    //public VecteurSerie occupants=new VecteurSerie();
    private VecteurSerie donneestransfert= new VecteurSerie();   //ajoutmik
    private Data donnees;              //ajoutmik
    private Individus indivtemp;       //ajoutmik 
    private int testPartieFinie = 0;       // a enlever a terme
    int nbMoutons;			//75;
    int nbLoups;			//3;
    int nbChiens;			//3;
    int nbObstacles; 	 	//1;

    // A Implementer
    public int tailleX = 2000;
    public int tailleY = 2000;

    private int nbCasesVert = 20;	// a changer , laurent - je pose 100 pixel de cot pour un case, donc avec 2000 de large 20 cases c'est bon. Mik
    private int nbCasesHoriz = 20;	// a changer , laurent 
    private int nbClients;
    int clientsActifs;
    public boolean fini;                //true quand il n'y a plus de client actif
    public boolean jeuInitie;
    public boolean jeuLance;
    public boolean partieFinie;         //true quand le jeu se finit (gain, galit...)

    public Carte ecoSysteme;
    public Comportement reactionsIndividus;
//    public ActionsIndividus actionsIndividus = new ActionsIndividus(this);    
    public VecteurSerie occupants = new VecteurSerie();
    private VecteurSerie terrain = new VecteurSerie(nbCasesHoriz*nbCasesVert);  

	// En faire des constantes
	// Ou alors c'est  mik de voir si il veut
	// Faire des ascenseurs pour les fentre client
	  
	//  rponse : je tente de faire du scrolling
//    static public int MAX_HORIZ = 100;		// lgrement agrandi pour les tests de scrolling
//    static public int MAX_VERT  = 100;		// idem
    // re reponse : c'est un peu grand 2000 * 2000 !
    
    Maitre master;
    HorlogeJoueurs fenJ;


    public VecteurSerie listeClient= new VecteurSerie();
    private Tour tour_de_jeu;
	    
    private int gagnant;
    private int moutonsSauves = 0;
    private int moutonsMorts = 0;
    /**
     * Operation
     *
     */
    public ServeurImpl(Maitre domi) throws java.rmi.RemoteException {
        super();
	jeuLance=false;
	jeuInitie=false;
	partieFinie=false;
	master=domi;
	//	init();
	//	jeuInitie=true;
	//fenJ =new HorlogeJoueurs(this, 1000);

    }

    /**
     * Operation
     * Lance le jeu vritablement : les tours commencent, les animaux bougent.
     */
    public void run(){	
	
	/*	if (nbClients==1) {               //S'il n'y a qu'un joueur, il ne contrle pas les loups, mais il y a quand mme nbLoups loups libres.
	    occupants.clear();
	    ecoSysteme.MiseAJour(tailleX, tailleY, nbCasesHoriz, nbCasesVert, nbClients, nbMoutons, nbChiens, nbLoups, nbObstacles, this);
	    }*/
	System.out.println("lancement de creeCommentReagir");
	reactionsIndividus.creeCommentReagir();
	System.out.println("creeCommentReagir effectue");
	tour_de_jeu = new Tour(this,40);
	jeuLance=true;
	
    }
    
/**************************************************************************************
 *	Dclaration des Clients
 **************************************************************************************/
    /**
     * Operation
     * On ne met pas de loups libres lorsqu'il y a plusieurs joueurs.
     */
    public int nouveauClient (String nom, int etat) throws java.rmi.RemoteException{
    	nom=testNom(nom);
		IdClient c = new IdClient(nom, etat, nbClients);
		listeClient.add(c);
		nbClients++;
		clientsActifs++;
		occupants.clear();
		ecoSysteme.MiseAJour(tailleX, tailleY, nbCasesHoriz, nbCasesVert, nbClients, nbMoutons, nbChiens, nbLoups, nbObstacles, this);
		return (nbClients-1);
    }
    /**
     * Operation
     *
     */
     public void finClient (int num) throws java.rmi.RemoteException{
	 // 1 : tat "Client a arrt" 
	 ((IdClient) (listeClient.elementAt(num))).metEtat(1);
	 clientsActifs--;
	 if (clientsActifs==0) {
	     arret();
	 }
     }
     
     /**
     * Test pour savoir si le nom du client est dj pris, et le cas chant le
modifier
     *
     *
     ***/
    public String testNom (String nom) {
	int i, test;
	if (nbClients!=0){
	    for (i=0;i<=nbClients-1;i++) {
	test=nom.compareTo(((IdClient)(listeClient.elementAt(i))).obtientNom());
	if (test==0) {
	    nom=nom+"bis";
	    testNom (nom);
	}
	    }
	}
return (nom);
    }

    /**
     * Operation
     * Permet au joueur qui a dclench le serveur de savoir combien de clients
     * ont rejoint la partie, et quand il veut de lancer la partie.
     */
     
     /*
    public void bilanClients() {
	//	temp = new VecteurSerie();
	//	temp.add("rien");	
	System.out.println("temp initie");
	fenJ =new HorlogeJoueurs(this, 1000);
	//	fenJ.run();	
    }*/

     
/**************************************************************************************
 *	Initialisation
 **************************************************************************************/
/**
     * Operation
     * Initialise le nombre d'animaux  mettre sur la carte 
     *  partir des donnes fournies par l'utilisateur qui 
     * a cr le serveur.
     */

    public void obtientNbVivants(String nm, String nc, String nl, String no) {
	// try Catch pour ignorer toute mauvaise intention de l'utilisateur
	// qui aurait mis du texte  la place d'un entier
	try {nbMoutons=(new Integer(nm)).intValue(); 
	nbChiens=(new Integer(nc)).intValue();
	nbLoups=(new Integer(nl)).intValue(); 
	nbObstacles=(new Integer(no)).intValue();}
	catch (java.lang.NumberFormatException e) {
	    nbMoutons=20;
	    nbChiens=3;
	    nbLoups=3;
	    nbObstacles=20;
	}
	
	//Eviter qu'il y ait trop d'animaux sur la carte
	if (nbChiens>5) {nbChiens=5;}
	if (nbLoups>4) {nbLoups=4;}
	if (nbMoutons>50) {nbMoutons=50;}
    }



    /**
     * Operation
     * Initialise le jeu : terrains et occupants.
     */
    public void init () {
	fini=false;
	nbClients=0;
	clientsActifs=0;
	System.out.println("init");
	ecoSysteme = new Carte();
	reactionsIndividus = new Comportement();

	//initTerrain();
	//initOccupants();

	jeuInitie=true;
	fenJ =new HorlogeJoueurs(this, 1000);
    }

    void ajouteOccupant(Individus petitMoutonARajouterOuAutre){
	occupants.add(petitMoutonARajouterOuAutre);
    }

    void ajouteTerrain(Data boutDeTerrainOuDEauOuDeForetOuAutre){
	terrain.add(boutDeTerrainOuDEauOuDeForetOuAutre);
    }

    void effaceTerrain(){
    }

    void effaceIndividus(){
    }

/**************************************************************************************
 * Rponses du serveur au client
 **************************************************************************************/
    
     /**
     * Operation
     *
     * @param moi
     */
    
    public void ouSuisJe ( Individus moi ) {
	  	double x, y, tx, ty, d; boolean act;
	  	int i;
		x  = ((Individus)moi).recupererPosHoriz();
		y  = ((Individus)moi).recupererPosVert();
  		d  = ((Individus)moi).recupererVision();

		for (i=0;i<occupants.size();i++){                            
	   		indivtemp = ((Individus)occupants.elementAt(i));
	   		tx = indivtemp.recupererPosHoriz();
	   		ty = indivtemp.recupererPosVert();
	   		act = indivtemp.actif;
	   		
	   		//e  = indivtemp.getEtat();
	   		if(/*e >= 0 && */distance(x, y, tx, ty) <= d && act){
	   			/*
	   			 *	en fait faut passer ici une rfrence vers l'individu
	   			 *	et que l'autre se dbrouille en face
	   			 *	tout seul
	   			 */
	   			((Individus)moi).voirIndividu(tx, ty, reagir(moi, indivtemp), i, act);
	   		}
		}	
    }
	public double distance (double x1, double y1, double x2, double y2){
		return Math.sqrt(Math.pow(x2-x1,2.0) + Math.pow(y2-y1,2.0));
	};

    /**
     * Operation
     * Donne le terrain cases par cases
     */
    public VecteurSerie donneTerrain() throws java.rmi.RemoteException {
		//System.out.println("donneTerrain");
		//return (((VecteurSerie)(terrain).clone()));
	while(!jeuInitie){};
	return terrain;
	/*
	if (jeuLance) {return terrain;} 
	else { 
	    
	    return (temp);
	    }
	*/
    }

    /**
     * Operation
     * Donne les individus vivants et leur position.
     */
    public VecteurSerie donneSituation() throws java.rmi.RemoteException {
    	int i;  
	while(!jeuInitie){};

	    donneestransfert = new VecteurSerie();                             

	    //System.out.println("donneSituation");	
      	    for (i=0;i<occupants.size();i++){                            
		indivtemp = ((Individus)(occupants.elementAt(i)));
		//indivtemp = ((Individus)occupants.elementAt(i));          
		donnees = new Data(indivtemp.recupererNom(), indivtemp.recupererPosHoriz(), 
				   indivtemp.recupererPosVert(), indivtemp.recupererPossesseur());
		//try{
		donneestransfert.add(donnees);//.clone());                               
		/*} 
		  catch (CloneNotSupportedException clo) {
		  System.out.println();
		  System.out.println("CloneNotSupported");
		  System.out.println(clo);
		  }*/
		}
	    return (donneestransfert); /*} // avec le else */
    }


    public int donneTailleCarteHoriz() throws java.rmi.RemoteException {
	return tailleX;
    }

    public int donneTailleCarteVert() throws java.rmi.RemoteException {
	return tailleY;
    }

/////////////////////////////////////////////////////////////////
// rcupration des ordres des joueurs
/////////////////////////////////////////////////////////////////

    public int recupereMouvement ( int qui, int cibleHoriz, int cibleVert ) throws java.rmi.RemoteException {
		((Controlable)(occupants.elementAt(qui))).regleCible(cibleHoriz,cibleVert);
		return 0;
    }

    public int recuperePointDeRoute ( int qui, int cibleHoriz, int cibleVert ) throws java.rmi.RemoteException {
		((Controlable)(occupants.elementAt(qui))).rajoutePointDeRoute(cibleHoriz,cibleVert);	
		return 0;	
    }
    
/////////////////////////////////////////////////////////////////
//  gestion des scores
/////////////////////////////////////////////////////////////////
	
    public VecteurSerie donneScore() throws java.rmi.RemoteException {
	int i;
	VecteurSerie transfertScore=new VecteurSerie();
	for (i=0;i<listeClient.size();i++){
	    Data score = new Data (((IdClient)(listeClient.elementAt(i))).obtientNom(),(((IdClient)listeClient.elementAt(i))).obtientScore());
	    transfertScore.add(score);
	}
	return (transfertScore);
    }
	
/////////////////////////////////////////////////////////////////
//  gestion de fin de partie
/////////////////////////////////////////////////////////////////    

    public void etUnMoutonSauve(){
	moutonsSauves++;
    }

    public void etUnMoutonMort(){
	moutonsMorts++;
    }

    public boolean testFinPartie(){
	int score,secondMax,maxScore;
	gagnant =0;
	
	if (nbClients>1){	
	    maxScore =((((IdClient)listeClient.elementAt(0))).obtientScore());
	    secondMax =((((IdClient)listeClient.elementAt(0))).obtientScore());
	
	    for (int i = 1; i<nbClients;i++){
		score=((((IdClient)listeClient.elementAt(i))).obtientScore());
		if (score>maxScore) {maxScore = score; gagnant = i;}
	    }
	    
	    for (int i = 1; i<nbClients;i++){
		score=((((IdClient)listeClient.elementAt(i))).obtientScore());
		if ((score>secondMax)&&(score<maxScore)) {secondMax = score;}
	    }

	    if (maxScore>secondMax+(nbMoutons*nbClients-moutonsMorts-moutonsSauves))
		{return true;}
	    else {return false;}
	}
	
	else if (nbMoutons*nbClients-moutonsMorts-moutonsSauves == 0)
	    {return true;}
	else {return false;}
    }
    
    public boolean demandePartieFinie () throws java.rmi.RemoteException{
	if (testFinPartie()) {
	    partieFinie=true;
	    System.out.println("ca va trancher");
	}

	return (partieFinie);
    }


    /**
     * Operation
     * Utile quand un client a gagn la partie
     */
    public Resultat finPartie (  ) throws java.rmi.RemoteException{
	return new Resultat( ((IdClient) (listeClient.elementAt(gagnant))).obtientNom(),((IdClient) (listeClient.elementAt(gagnant))).obtientScore(),nbMoutons*nbClients);
    }

    /**
     * Operation
     * Est dclenche quand il n'y a plus de clients
     */
    public void arret (  ) throws java.rmi.RemoteException{
	fini=true;
	master.arret();
    }

    /**
     * Operation
     * 
     */
    public String comTest() throws java.rmi.RemoteException {
		return ("Ca marche");
    }

    public void ajouteTypeIndividus(Individus indiv){
    	String nom = (indiv.getClass().getName());
		reactionsIndividus.ajouteType(nom);    	
    }

	public ComportementIndividu reagir(Individus moi, Individus autrui){
    	String nomMoi   = (moi.getClass().getName());
    	String nomAutrui= (autrui.getClass().getName());
    	//System.out.println(nomMoi + " &&& "+nomAutrui);
    	return reactionsIndividus.reagir(nomMoi, nomAutrui);
	}
	
	public IdClient recupereIdClient(int numeroClient){
		//System.out.println("***"+numeroClient+"***");
		//System.out.println("***"+numeroClient+"***");
		return (IdClient)listeClient.elementAt(numeroClient);		
	}
	public void declencheMiseAJour(){
		for(int i=0; i < listeClient.size(); i++){
			((IdClient)(listeClient.elementAt(i))).declencheMiseAJour();
		}
	}
	public void majEffectuee(int numeroClient){
		((IdClient)listeClient.elementAt(numeroClient)).majEffectuee();
	}
}
