package serveur.individus;

import java.lang.CloneNotSupportedException;
import serveur.ServeurImpl;

abstract public class Individus implements Cloneable {
  /** Attributes */
  protected double posVert;
  protected double posHoriz;
  //protected int repulsivite;
  private String nom;     //AjoutMik
  private String possesseur = "";  // ajoutmik  
  //protected int etat = 100;		// Pour l'instant : nb de pts de vie
  protected ServeurImpl monServeur;
  public boolean actif = true;

	// C'est tout a fait normal qu'une bergerie voit les moutons, pour pouvoir les sauver...
  protected int rayon;
  private double distVision;
  //protected Comportement comportement;

  /*
   *
   * Faudrait initialiser les individus et leur associer un serveur
   *	plutot que de le passer en argument...
   *
   *	Comment crer une brebis ????
   *
   */
   
///////////////////////////////////////////////////////
//	Interface ext.
///////////////////////////////////////////////////////
	public double recupererPosVert(){return posVert;}
	public double recupererPosHoriz(){return posHoriz;}
	//public int getRepulsivite(){return repulsivite;}
	public void definirNom(String nouveauNom){nom = nouveauNom;}
	public String recupererNom(){return nom;}
	public String recupererPossesseur(){return possesseur;}  //ajoutmik
	public void definirPossesseur(String s){possesseur=s;}  //ajoutmik
//	public int getEtat(){return etat;}

	public void definirVision(double nouveauVision){distVision = nouveauVision;}
	public double recupererVision(){return distVision;}
	public int recupererRayon(){return rayon;}

///////////////////////////////////////////////////////
//	Fonctions de base
///////////////////////////////////////////////////////

	abstract public void action ();
	abstract public void voirIndividu ( double x, double y, ComportementIndividu action, int numIndiv, boolean activite);

	public Individus(ServeurImpl serv){
		monServeur = serv;
		serv.ajouteTypeIndividus(this);
	};
	public Individus(){}
}

