package serveur.individus.environnement;

import serveur.IdClient;
import serveur.ServeurImpl;
import serveur.individus.*;
import serveur.individus.vivant.*;

public class Bergerie extends Individus {

	private int moutonASauver;
	private int numeroClient;

    public void action () {
    	moutonASauver = -1;
		monServeur.ouSuisJe(this);
		reaction();
    }

	public void reaction(){
		if(moutonASauver>0){
			((Mouton)(monServeur.occupants.elementAt(moutonASauver))).sauver();
			((IdClient)monServeur.listeClient.elementAt(numeroClient-1)).metScore(1);
		}
	}

	public void voirIndividu ( double x, double y, ComportementIndividu action, int numIndiv, boolean activite){
		if (action.recupererAction()=="sauver" && activite){
			moutonASauver = numIndiv;	
		}
	}

	public void tuer(){};
	
    public Bergerie (int x, int y, String poss, int num, ServeurImpl serv) {
    	super(serv);
		posHoriz=x;
		posVert=y;
		numeroClient = num;
		definirNom("bergerie" + num);		// A changer qd il y aura un gif avec
		definirVision(120);
		rayon=50;
    }
}

