package serveur.individus.environnement;

import serveur.ServeurImpl;
import serveur.individus.*;

abstract public class Environnement extends Individus {

	// Un obstacle ca bouge / reagit pas
    public void action (){}
    public void tuer(){}
    public void voirIndividu ( double x, double y, ComportementIndividu action, int numIndiv, boolean activite){}
	
    public Environnement (int x, int y, String poss, ServeurImpl serv) {
    	super(serv);
		posHoriz=x;
		posVert=y;
		definirPossesseur(poss);
		//repulsivite=-40;		// ngatif pour les obstacles
    }
}

